//Generated by ParseQx version 0.0.1 from qooxdoo 5.0.2 API.

unit qx.event;

interface

{$modeswitch externalclass}

uses
  JS, Web, qx;

type

   //forward declarations
   //TEvent_Manager and TEvent_Registration reference each other
  TEvent_Registration = class;


  TType_Event = class external name 'qx.event.type.Event' (TCore_Object)
    function clone (embryo:TType_Event = nil): TType_Event;
    function getBubbles: Boolean;
    function getCurrentTarget: TJSElement;
    function getDefaultPrevented: Boolean;
    function getEventPhase: Integer;
    function getOriginalTarget: TJSElement;
    function getPropagationStopped: Boolean;
    function getRelatedTarget: TJSElement;
    function getTarget: TJSElement;
    function getTimeStamp: Integer;
    function getType: string;
    function init (canBubble:Boolean = False; cancelable:Boolean = False): TType_Event;
    function isCancelable: Boolean;
    procedure preventDefault;
    procedure setBubbles (bubbles:Boolean);
    procedure setCancelable (cancelable:Boolean);
    procedure setCurrentTarget (currentTarget:TJSElement);
    procedure setEventPhase (eventPhase:Integer);
    procedure setOriginalTarget (originalTarget:TJSElement);
    procedure setRelatedTarget (relatedTarget:TJSElement);
    procedure setTarget (target:TJSElement);
    procedure setType (&type:string);
    procedure stop;
    procedure stopPropagation;
  end;


  TType_Data = class external name 'qx.event.type.Data' (TType_Event)
    function clone (embryo:TType_Data = nil): TType_Data;
    function getData: JSValue;
    function getOldData: JSValue;
    function init (data:JSValue; old:JSValue = nil; cancelable:Boolean = False): TType_Data;
  end;


  TType_Native = class external name 'qx.event.type.Native' (TType_Event)
    function getNativeEvent: TJSEvent;
    function getReturnValue: string;
    function init (nativeEvent:TJSEvent; target:TJSObject = nil; relatedTarget:TJSObject = nil; canBubble:Boolean = False; cancelable:Boolean = False): TType_Event;
    procedure preventDefault;
    procedure setReturnValue (returnValue:string = '');
  end;


  TType_Dom = class external name 'qx.event.type.Dom' (TType_Native)
    function getModifiers: Integer;
    function isAltPressed: Boolean;
    function isCtrlOrCommandPressed: Boolean;
    function isCtrlPressed: Boolean;
    function isMetaPressed: Boolean;
    function isShiftPressed: Boolean;
  end;


  TType_Mouse = class external name 'qx.event.type.Mouse' (TType_Dom)
    function getButton: string;
    function getDocumentLeft: Integer;
    function getDocumentTop: Integer;
    function getRelatedTarget: TJSElement;
    function getScreenLeft: Integer;
    function getScreenTop: Integer;
    function getViewportLeft: Integer;
    function getViewportTop: Integer;
    function isLeftPressed: Boolean;
    function isMiddlePressed: Boolean;
    function isRightPressed: Boolean;
  end;


  TType_Pointer = class external name 'qx.event.type.Pointer' (TType_Mouse)
    function getHeight: JSValue;
    function getPointerId: JSValue;
    function getPointerType: string;
    function getPressure: JSValue;
    function getTiltX: JSValue;
    function getTiltY: JSValue;
    function getWidth: JSValue;
    function isPrimary: Boolean;
  end;


  TEvent_Manager = class external name 'qx.event.Manager' (TJSObject)
    constructor New (win:TJSWindow; registration:TEvent_Registration);
    class function getNextUniqueId: string;
    function addListener (target:TJSObject; &type:string; listener:JSValue; self:TJSObject = nil; capture:Boolean = False): string;
    function dispatchEvent (target:TJSObject; event:TType_Event): Boolean;
    procedure dispose;
    function findHandler (target:JSValue; &type:string): TJSObject;
    function getDispatcher (clazz:TJSObject): TJSObject;
    function getHandler (clazz:TJSObject): TJSObject;
    function getListeners (target:TJSObject; &type:string; capture:Boolean = False): TJSArray;
    function getWindow: TJSWindow;
    function getWindowId: string;
    function hasListener (target:TJSObject; &type:string; capture:Boolean = False): Boolean;
    procedure importListeners (target:TJSObject; list:TJSObject);
    function removeAllListeners (target:TJSObject): Boolean;
    function removeListener (target:TJSObject; &type:string; listener:JSValue; self:TJSObject = nil; capture:Boolean = False): Boolean;
    function removeListenerById (target:TJSObject; id:string): Boolean;
    function serializeListeners (target:TJSObject): TJSObject;
  end;


  TEvent_Emitter = class external name 'qx.event.Emitter' (TJSObject)
    function addListener (name:string; listener:JSValue; ctx:JSValue = nil): Integer;
    function addListenerOnce (name:string; listener:JSValue; ctx:JSValue = nil): Integer;
    procedure emit (name:string; data:JSValue = nil);
    function off (name:string; listener:JSValue; ctx:JSValue = nil): Integer;
    function offById (id:Integer): Integer;
    function on (name:string; listener:JSValue; ctx:JSValue = nil): Integer;
    function once (name:string; listener:JSValue; ctx:JSValue = nil): Integer;
    procedure removeListener (name:string; listener:JSValue; ctx:JSValue = nil);
    procedure removeListenerById (id:Integer);
  end;


  TEvent_Registration = class external name 'qx.event.Registration' (TJSObject)
    class procedure addDispatcher (dispatcher:TJSObject; priority:Integer);
    class procedure addHandler (handler:TJSObject);
    class function addListener (target:TJSObject; &type:string; listener:JSValue; self:TJSObject = nil; capture:Boolean = False): JSValue;
    class function createEvent (&type:string; clazz:TJSObject = nil; args:TJSArray = nil): TType_Event;
    class function dispatchEvent (target:TJSObject; event:TType_Event): Boolean;
    class function fireEvent (target:TJSObject; &type:string; clazz:TJSObject = nil; args:TJSArray = nil): Boolean;
    class function fireNonBubblingEvent (target:TJSObject; &type:string; clazz:TJSObject = nil; args:TJSArray = nil): Boolean;
    class function getDispatchers: TJSObject;
    class function getHandlers: TJSObject;
    class function getManager (target:TJSObject): TEvent_Manager;
    class function hasListener (target:TJSObject; &type:string; capture:Boolean = False): Boolean;
    class function removeAllListeners (target:TJSObject): Boolean;
    class function removeListener (target:TJSObject; &type:string; listener:JSValue; self:TJSObject = nil; capture:Boolean = False): Boolean;
    class function removeListenerById (target:TJSObject; id:JSValue): Boolean;
    class procedure removeManager (mgr:TEvent_Manager);
    class function serializeListeners (target:TJSObject): TJSObject;
  end;


implementation

end.
